Fixed pnd_run.sh so -m and -u work, yay for previewpics
[pandora-libraries.git] / testdata / scripts / pnd_run.sh
1 #!/bin/bash
2  
3 #Usage: pnd_run.sh -p your.pnd -e executeable [-a "(arguments)"] [ -s "cd to folder inside pnd"] [-b UID (name of mountpoint/pandora/appdata)] [-x close x before launching(script needs to be started with nohup for this to work]
4 # -s startdir
5 # arguments can be inside -e, -a is optional
6  
7 #/etc/sudoers needs to be adjusted if you touch any of the sudo lines
8  
9 # look at the comments in the nox part, adjust 
10 #use "lsof /usr/lib/libX11.so.6 | awk '{print $1}'| sort | uniq > whitelist" with nothing running to generate the whitelist
11  
12 #launch the script with nohup for -x to work!
13  
14 #todo - no proper order
15 #validate params better
16 #make uid/basename mandatory (and rename var, its confusing!)
17 #find a clean way of shutting down x without a fixed dm, mabye avoid nohup usage somehow
18 #add options to just mount iso without union and to mount the union later
19 #cleanup
20 #Rewrite! - this sucks
21  
22 # parse arguments
23 TEMP=`getopt -o p:e:a:b:s:m::u::n::x::j:c: -- "$@"`
24  
25 if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
26  
27 # Note the quotes around `$TEMP': they are essential!
28 eval set -- "$TEMP"
29  
30 while true ; do
31         case "$1" in
32                 -p) echo "pnd set to \`$2'" ;PND=$2;shift 2;;
33                 -e) echo "exec set to \`$2'" ;EXENAME=$2;shift 2 ;;
34 #               -n) echo "n set, no union pls!";NOUNION=1;shift 2;; # we will reuse -n soon,stop using it if you still did!
35                 -b) echo "BASENAME set to $2";BASENAME=$2;shift 2;;
36                 -s) echo "startdir set to $2";STARTDIR=$2;shift 2;;
37                 -m) echo "mount";mount=1;shift 2;;
38                 -u) echo "umount";umount=1;shift 2;;
39                 -x) echo "no x";nox=1;shift 2;;
40                 -j) echo "join/ also mount those folders";append=$2;shift 2;;
41                 -c) echo "set cpu speed to";cpuspeed=$2;shift 2;;
42                 -a) 
43                         case "$2" in
44                                 "") echo "no arguments"; shift 2 ;;
45                                 *)  echo "args set to \`$2'" ;ARGUMENTS=$2;shift 2 ;;
46                         esac ;;
47                 --) shift ; break ;;
48                 *) echo "Error while parsing arguments!" ; exit 1 ;;
49         esac
50 done
51
52 if [ ! $PND ]; then #check if theres a pnd suplied, need to clean that up a bit more
53         echo "Usage: pnd_run.sh -p your.pnd -e executeable [-a \"(arguments)\"] [ -s \"cd to folder inside pnd\"] [-b UID (name of mountpoint/pandora/appdata)] [-x close x before launching(script needs to be started with nohup for this to work]"
54         exit 1
55 fi
56 if [ ! $EXENAME ]; then
57         if [ ! $mount ] && [ ! $umount ]; then
58                 echo "Usage: pnd_run.sh -p your.pnd -e executeable [-a \"(arguments)\"] [ -s \"cd to folder inside pnd\"] [-b UID (name of mountpoint/pandora/appdata)] [-x close x before launching(script needs to be started with nohup for this to work]"
59                 echo "Usage for mounting/umounting pnd_run.sh -p your.pnd -b uid -m or -u"
60                 exit 1
61         fi
62 fi
63
64 if [ $(pidof X) ]; then 
65 unset $nox
66 fi
67
68 fork () {
69 echo in fork!
70 if [ $nox ]; then #the app doesnt want x to run, so we kill it and restart it once the app quits
71         applist=$(lsof /usr/lib/libX11.so.6 | awk '{print $1}'| sort | uniq)
72         whitelist=$(cat ~/pndtest/whitelist) #adjust this to a fixed whitelist, maybe in the config dir
73         filteredlist=$(echo -e "$applist\n\n$whitelist\n\n$whitelist" | sort | uniq -u) #whitelist appended two times so those items are always removed
74         if [ ${#filteredlist} -ge 1 ]; then
75                 message=$(echo -e "The following applications are still running, are you sure you want to close x? \n$filteredlist")
76                 echo -e ?ae[34me[30m?
77                 xmessage -center "$message", -buttons yes,no
78                 if [ $? = 102 ]; then
79                 exit 1
80                 fi
81                 sudo /etc/init.d/slim-init stop
82                 sleep 5s
83         else
84                 echo -e ?ae[34me[30m?
85                 xmessage -center "killing x, nothing of value will be lost", -buttons ok,cancel
86                 if [ $? = 102 ]; then
87                 exit 1
88                 fi
89                 # close x now, do we want to use slim stop or just kill x?
90                 sudo /etc/init.d/slim-init stop
91                 sleep 5s
92         fi
93 fi
94  
95 #vars
96 DFS=$(file -b $PND | awk '{ print $1 }') #is -p a zip/iso or folder?
97 MOUNTPOINT=$(df $PND | sed -ne 's/.*\% \(\S*\)/\1/p' | tail -n1) #find out on which mountpoint the pnd is
98 if [ ! -d "$MOUNTPOINT" ]; then MOUNTPOINT="/"; fi #make sure folder exists, if it doesnt assume rootfs
99 FILESYSTEM=$(mount | grep "on $MOUNTPOINT " | grep -v rootfs | awk '{print $5}' | tail -n1) #get filesystem appdata is on to determine aufs options
100 echo "Filesystem is $FILESYSTEM"
101 #if the pnd is on / set mountpoint to "" so we dont and up with // at the start,
102 #this is to make sure sudo doesnt get confused
103 if [ $MOUNTPOINT = "/" ]; then MOUNTPOINT=""; fi
104 echo "mountpoint: $MOUNTPOINT"
105  
106 #BASENAME really should be something sensible and somewhat unique
107 #if -b is set use that as basename, else generate it from PND
108 #get basename (strip extension if file) for union mountpoints etc, maybe  this should be changed to something specified inside the xml
109 #this should probably be changed to .... something more sensible
110 if [ ! $BASENAME ]; then BASENAME=$(basename "$PND" | cut -d'.' -f1) ; fi
111  
112  
113  
114 oCWD=$(pwd)
115
116
117  
118 #create mountpoints, check if they exist already first to avoid annoying error messages
119 if [ ! -d /mnt/pnd/$BASENAME ]; then sudo mkdir -p /mnt/pnd/$BASENAME ; fi #mountpoint for iso, ro
120 #writeable dir for union
121 if [ ! -d $MOUNTPOINT/pandora/appdata/$BASENAME ]; then sudo mkdir -p $MOUNTPOINT/pandora/appdata/$BASENAME; sudo chmod -R a+xrw $MOUNTPOINT/pandora/appdata/$BASENAME; fi
122 if [ ! -d /mnt/utmp/$BASENAME ]; then sudo mkdir -p /mnt/utmp/$BASENAME; fi #union over the two
123
124 #mount
125  
126 if [ ! $umount ]; then
127         if [ ! $cpuspeed -eq $(cat /proc/pandora/cpu_mhz_max) ]; then 
128           gksu --message "$BASENAME wants to set the cpu speed to $cpuspeed, enter root password to allow" echo $cpuspeed > /proc/pandora/cpu_mhz_max
129         fi
130         #is the union already mounted? if not mount evrything, else launch the stuff
131         mount | grep "on /mnt/utmp/$BASENAME type" # > /dev/null
132         if [ ! $? -eq 0 ]; then 
133
134                 echo not mounted on loop yet, doing so
135                 #check if pnd is already attached to loop 
136                 LOOP=$(sudo losetup -a | grep $PND | tail -n1 | awk -F: '{print $1}')
137                 #check if the loop device is already mounted
138                 loopmountedon=$( mount | grep $(mount | grep $LOOP | awk '{print $3}') | grep utmp | awk '{print $3}' )
139                 if [ ! $loopmountedon ]; then #check if the pnd is already attached to some loop device but not used
140                         FREELOOP=$LOOP 
141                         #reuse existing loop
142                         if [ ! $LOOP ]; then
143                                 FREELOOP=$(sudo /sbin/losetup -f) #get first free loop device
144                                 if [ ! $FREELOOP  ]; then  # no free loop device, create a new one
145                                             #find a free loop device and use it 
146                                             usedminor=$(sudo /sbin/losetup -a | tail -n1)
147                                             usedminor=${usedminor:9:1}
148                                             echo usedminor $usedminor
149                                             freeminor=$(($usedminor+1))
150                                             echo freeminor $freeminor
151                                             sudo mknod -m777 /dev/loop$freeminor b 7 $freeminor
152                                             FREELOOP=/dev/loop$freeminor
153                                 fi                      
154                         fi
155                           #detect fs
156                         
157                         if [ $DFS = ISO ]; then
158                                 sudo /sbin/losetup $FREELOOP $PND #attach the pnd to the loop device
159                                 mntline="sudo mount $FREELOOP /mnt/pnd/$BASENAME/" #setup the mountline for later
160                                 #mntline="sudo mount -o loop,mode=777 $PND /mnt/pnd/$BASENAME"
161                                 echo "Filetype is $DFS"
162                         elif [ $DFS = directory ]; then
163                                   mntline="sudo mount --bind -o ro $PND /mnt/pnd/$BASENAME"
164                           #we bind the folder, now it can be treated in a unified way ATENTION: -o ro doesnt work for --bind at least on 25, on 26 its possible using remount, may have changed on 27
165                                   echo "Filetype is $DFS"
166                         elif [ $DFS = Squashfs ]; then
167                                   sudo /sbin/losetup $FREELOOP $PND #attach the pnd to the loop device
168                                   mntline="sudo mount -t squashfs  $FREELOOP /mnt/pnd/$BASENAME"
169                                   echo "Filetype is $DFS"
170                         else
171                                   echo "error determining fs, output was $DFS"
172                                   exit 1;
173                         fi
174
175                         echo "$mntline"
176                         $mntline #mount the pnd/folder
177                         echo "mounting union!"
178                         if [ $FILESYSTEM = vfat ]; then # use noplink on fat, dont on other fs's 
179                                 #append is fucking dirty, need to clean that up
180                                 sudo mount -t aufs -o exec,noplink,dirs=$MOUNTPOINT/pandora/appdata/$BASENAME=rw+nolwh:/mnt/pnd/$BASENAME=rr$append none /mnt/utmp/$BASENAME # put union on top
181                                 else
182                                 sudo mount -t aufs -o exec,dirs=$MOUNTPOINT/pandora/appdata/$BASENAME=rw+nolwh:/mnt/pnd/$BASENAME=rr$append none /mnt/utmp/$BASENAME # put union on top
183                         fi
184                 else #the pnd is already mounted but a mount was requested with a different basename/uid, just link it there
185                               echo $LOOP already mounted on $loopmountedon skipping losetup - putting link to old mount
186                               #this is bullshit
187                               sudo rmdir /mnt/utmp/$BASENAME
188                               sudo ln -s $loopmountedon /mnt/utmp/$BASENAME 
189                 fi
190         
191         else
192                 echo "Union already mounted"
193         fi
194  
195         if [ $mount ]; then echo "mounted /mnt/utmp/$BASENAME"; exit 1; fi; #mount only, die here
196         
197         cd /mnt/utmp/$BASENAME # cd to union mount
198         if [ $STARTDIR ]; then cd $STARTDIR; fi #cd to folder specified by the optional arg -s
199         LD_LIBRARY_PATH=/mnt/utmp/$BASENAME ./$EXENAME $ARGUMENTS # execute app with ld_lib_path set to the union mount, a bit evil but i think its a good solution
200         #the app could have exited now, OR it went into bg, we still need to wait in that case till it really quits!
201         PID=`pidof -o %PPID -x $EXENAME` #get pid of app
202         while [ "$PID" ] #wait till we get no pid back for tha app, again a bit ugly, but it works
203         do
204         sleep 10s
205         PID=`pidof -o %PPID -x $EXENAME`
206         done
207         echo app exited
208  
209         #app exited
210         cd $oCWD #cd out of the mountpoint so we can umount, doesnt really matter to where...
211 else
212 echo "-u set, nothing to do here"
213 fi
214  
215  
216 #clean up
217 sudo rmdir /mnt/utmp/$BASENAME
218 sudo rm /mnt/utmp/$BASENAME
219 sudo umount /mnt/utmp/$BASENAME #umount union
220 if [ $? -eq 0 ]; then # check if the umount was successfull, if it wasnt it would mean that theres still something running so we skip this stuff, this WILL lead to clutter if it happens, so we should make damn sure it never happens
221         #umount the actual pnd
222         sudo umount /mnt/pnd/$BASENAME
223         #delete folders created by aufs if empty
224         sudo rmdir $MOUNTPOINT/pandora/appdata/$BASENAME/.wh..wh.plnk
225         sudo rmdir $MOUNTPOINT/pandora/appdata/$BASENAME/.wh..wh..tmp
226         #delete appdata folder and ancestors if empty
227         sudo rmdir -p $MOUNTPOINT/pandora/appdata/$BASENAME/
228         #delete tmp mountpoint
229         sudo rmdir /mnt/utmp/$BASENAME
230         if [ $DFS = ISO ] || [ $DFS = Squashfs ]; then # check if we where running an iso, clean up loop device if we did
231                 LOOP=$(sudo losetup -a | grep $(basename $PND) | tail -n1 | awk -F: '{print $1}')
232                 sudo /sbin/losetup -d $LOOP
233                 sudo rm $LOOP
234         fi
235         sudo rmdir /mnt/pnd/$BASENAME #delete pnd mountpoint
236         echo cleanup done
237 else
238 echo umount failed, didnt clean up
239 fi
240
241 if [ $nox ]; then #restart x if it was killed
242 echo "starting x in 5s"
243 sleep 5
244 sudo /etc/init.d/slim-init start
245 fi
246
247 } #function end!
248
249 if [ $nox ]; then
250 echo forking now!
251 fork &> /tmp/pndrun$BASENAME$mount.out & 
252 disown
253 else
254 echo Running with x, not disowning!
255 fork &> /tmp/pndrun$BASENAME$mount.out
256 fi